Package org.springframework.scheduling.quartz

# Class QuartzJobBean

java.lang.Object
org.springframework.scheduling.quartz.QuartzJobBean

All Implemented Interfaces:
  `Job`

Direct Known Subclasses:
  `MethodInvokingJobDetailFactoryBean.MethodInvokingJob`

public abstract class QuartzJobBean extends Object implements Job
Simple implementation of the Quartz Job interface, applying the passed-in JobDataMap and also the SchedulerContext as bean property values. This is appropriate because a new Job instance will be created for each execution. JobDataMap entries will override SchedulerContext entries with the same keys.

For example, let's assume that the JobDataMap contains a key "myParam" with value "5": The Job implementation can then expose a bean property "myParam" of type int to receive such a value, i.e. a method "setMyParam(int)". This will also work for complex types like business objects etc.

Note that the preferred way to apply dependency injection to Job instances is via a JobFactory: that is, to specify `SpringBeanJobFactory` as Quartz JobFactory (typically via `SchedulerFactoryBean's "jobFactory" property`). This allows to implement dependency-injected Quartz Jobs without a dependency on Spring base classes.

Since:
  18.02.2004
Author:
  Juergen Hoeller
See Also:
  - `JobExecutionContext.getMergedJobDataMap()`
  - `Scheduler.getContext()`
  - `SchedulerFactoryBean.setSchedulerContextAsMap(java.util.Map<java.lang.String, ?>)`
  - `SpringBeanJobFactory`
  - `SchedulerFactoryBean.setJobFactory(org.quartz.spi.JobFactory)`

## Constructor Summary

Constructors
Constructor
Description
`QuartzJobBean()`

## Method Summary

Modifier and Type
Method
Description
`final void`
`execute(JobExecutionContext context)`
This implementation applies the passed-in job data map as bean property values, and delegates to `executeInternal` afterwards.
`protected abstract void`
`executeInternal(JobExecutionContext context)`
Execute the actual job.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### QuartzJobBean

public QuartzJobBean()

## Method Details

### execute

public final void execute(JobExecutionContext context) throws JobExecutionException
This implementation applies the passed-in job data map as bean property values, and delegates to `executeInternal` afterwards.

Specified by:
  `execute` in interface `Job`
Throws:
  `JobExecutionException`
See Also:
  - `executeInternal(org.quartz.JobExecutionContext)`

### executeInternal

protected abstract void executeInternal(JobExecutionContext context) throws JobExecutionException
Execute the actual job. The job data map will already have been applied as bean property values by execute. The contract is exactly the same as for the standard Quartz execute method.

Throws:
  `JobExecutionException`
See Also:
  - `execute(org.quartz.JobExecutionContext)`